#include <iomanip>
#include <vector>
#include <fstream> 
#include <tuple>
using namespace std;

ifstream fin("acces1.in");
ofstream fout("acces1.out");

// type alias-uri

using VI  = vector<int>;
using VVI = vector<VI>;     // tipul matrice de int
using VC  = vector<char>;
using VVC = vector<VC>;     // matrice de caractere
using PI  = pair<int, int>;

const int Inf = 0x3f3f3f3f,
          di[] = {-1, 0, 1, 0},
          dj[] = {0, 1, 0, -1};
          
// matrici vide!
VVC L; // labirintul
VVI c;   // c[i][j] = distanta minima (nr minim de pasi)
              
int n, m;
queue<PI> Q; // coada vida

void CitesteDate();
void Lee(VVI& c); // obligatoriu c este prin referinta!
bool Ok(int i, int j);
void ScrieSol();

int main()
{
    CitesteDate();
    Lee(c);
    ScrieSol();
}

// directive de Precompilare
#define iv (i + di[d])
#define jv (j + dj[d])

// O(n * m)
void Lee(VVI& c)
{
    int i, j;
    while (!Q.empty())  // cat timp coada nu este vida
    {
		// C++11
        tie(i, j) = Q.front();
        Q.pop();       // Stergem primul element din coada 
            
        for (int d = 0; d < 4; ++d)
            if (Ok(iv,jv) && c[iv][jv] > c[i][j] + 1)
            {
                c[iv][jv] = c[i][j] + 1;
                Q.push({iv, jv});   
            }
    }
}

bool Ok(int i, int j)
{
    if (i < 1 || i > n || j < 1 || j > m) // in afara matricei
        return false;
        
    if (L[i][j] == '#') // obstacol
        return false;
    
    return true;
}

void CitesteDate()
{
    fin >> n >> m;
    c = VVI(n + 1, VI(m + 1, Inf)); // aici se creaza matricea!
    L = VVC(n + 1, VC(m + 1));      // cream matricea L[][]

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j)
        {
            fin >> L[i][j];
            if (L[i][j] == 'P')
            {
                c[i][j] = 0;
                Q.push({i, j});
            }
        }
}

void ScrieSol()
{
    for (int i = 1; i <= n; ++i, fout << '\n')
    {
        for (int j = 1; j <= m; ++j)
            if (L[i][j] == '#')
                fout << "# ";
            else
                if (c[i][j] == Inf)
                    fout << "- ";
                else
                    fout << c[i][j] << ' ';
    }
}





