#include <iomanip>
#include <vector>
#include <fstream> // Directive de Precompilare (de Preprocesare)
#include <queue>
#include <tuple>
using namespace std;

ifstream fin("paznici.in");
ofstream fout("paznici.out");

using VB  = vector<bool>;
using VVB = vector<VB>;     // tipul matrice de bool
using VI  = vector<int>;
using VVI = vector<VI>;     // tipul matrice de bool

using VC  = vector<char>;
using VVC = vector<VC>;     // matrice de caractere

const int Inf = 0x3f3f3f3f,
	      di[] = {-1, 0, 1, 0},
	      dj[] = {0, 1, 0, -1};
	      

// matrici vide!
VVC L; // labirintul
VVI c;   // c[i][j] = distanta minima (nr minim de pasi)
int p;   // nr de paznici
VVB a;           
int n, m;


void CitesteDate();
void Lee(int i, int j, int d, VVI& c); // obligatoriu c este prin referinta!
bool Ok(int i, int j);
void ScrieSol();

int main()
{
	fin >> n >> m >> p;
	c = VVI(n + 1, VI(m + 1, Inf)); // aici se creaza matricea!
	L = VVC(n + 1, VC(m + 1));      // cream matricea L[][]
	a = VVB(n + 1, VB(m + 1, false));
	
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			fin >> L[i][j];
	
	for (int k = 1, i, j, d; k <= p; ++k)
	{
		fin >> i >> j >> d;
		Lee(i, j, d, c);
	}
	
	ScrieSol();
/*	
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
			fout << a[i][j] << ' ';
		fout << '\n';
	}
	*/ 
}

// directive de Precompilare
#define iv (i + di[d])
#define jv (j + dj[d])

// O(n * m)
void Lee(int i, int j, int dist, VVI& c)
{
	queue<pair<int, int>> Q; // coada vida <i, j, d>
	
	c = VVI(n + 1, VI(m + 1, Inf));
	c[i][j] = 0;
	a[i][j] = true;
	Q.push({i, j});
	
	while (!Q.empty())  // cat timp coada nu este vida
	{
		tie(i, j) = Q.front();
		Q.pop();       // Stergem primul element din coada 
			
		for (int d = 0; d < 4; ++d)
			if (Ok(iv,jv) && c[i][j] + 1 < c[iv][jv] && c[i][j] + 1 <= dist)
			{
				c[iv][jv] = c[i][j] + 1;
				a[iv][jv] = true;
				
				Q.push({iv, jv});   
			}
	}
}

bool Ok(int i, int j)
{
	if (i < 1 || i > n || j < 1 || j > m) // in afara matricei
		return false;
		
	if (L[i][j] == '#') // obstacol
		return false;
	
	return true;
}


void ScrieSol()
{
	int camere = 0;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j)
			if (L[i][j] == '-' && a[i][j] == false)
				camere++;
	}
	
	fout << camere << '\n';
}






